## gnudatalanguage 0.9.1

=== CMakeLists.txt ===
# tested with 2.4 and doesn't seem to run.
cmake_minimum_required(VERSION 2.6 FATAL_ERROR)

project(GDL)

set(VERSION "0.9 CVS")
enable_testing()

include(CheckIncludeFile)
include(CheckIncludeFileCXX)
include(CheckLibraryExists)
include(CheckFunctionExists)
include(CheckCSourceRuns)
include(FindPkgConfig)
include(FindPackageHandleStandardArgs)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_SOURCE_DIR}/CMakeModules)

#### Default cached values
set(PYTHON_MODULE OFF CACHE BOOL "Build GDL as a Python module ?")

set(X11 ON CACHE BOOL "Enable X11 ?") 
set(X11DIR "" CACHE PATH "Specify X11 directory tree")

set(READLINE ON CACHE BOOL "Enable GNU Readline ?")
set(READLINEDIR "" CACHE PATH "Specify the GNU readline directory tree")

set(OLDPLPLOT OFF CACHE BOOL "Enable old plplot ?")
set(PLPLOTDIR "" CACHE PATH "Specify the plplot directory tree")

set(GSLDIR "" CACHE PATH "Specify the GSL directory tree")

set(ZLIBDIR "" CACHE PATH "specify the Zlib directory tree")

set(WXWIDGETS OFF CACHE BOOL "Enable WxWidgets ?")
set(WXWIDGETSDIR "" CACHE PATH "Specify WxWidgets directory tree")

set(UDUNITS OFF CACHE BOOL "Enable UDUNITS-2 ?")
set(UDUNITSDIR "" CACHE PATH "Specify the UDUNITS-2 directory tree")

set(GRIB OFF CACHE BOOL "Enable Grib ?")
set(GRIBDIR "" CACHE PATH "Specifiy the GRIB directory tree")

set(MAGICK ON CACHE BOOL "Enable Magick ?")
set(MAGICKDIR "" CACHE PATH "Specifiy the ImageMagick directory tree")

set(NETCDF ON CACHE BOOL "Enable NetCDF ?")
set(NETCDFDIR "" CACHE PATH "Specifiy the netCDF directory tree")

set(HDF ON CACHE BOOL "Enable Hdf ?")
set(HDFDIR "" CACHE PATH "Specifiy the HDF directory tree")

set(HDF5 ON CACHE BOOL "Enable Hdf5 ?")
set(HDF5DIR "" CACHE PATH "Specifiy the HDF5 directory tree")

set(FFTW ON CACHE BOOL "Enable FFTW ?")
set(FFTWDIR "" CACHE PATH "Specifiy the FFTW directory tree")

set(LIBPROJ4 OFF CACHE BOOL "Enable LIBPROJ4 ?")
set(LIBPROJ4DIR "" CACHE PATH "Specifiy the LIBPROJ4 directory tree")

set(MPICH OFF CACHE BOOL "Enable MPICH ?")
set(MPICHDIR "" CACHE PATH "Specify the MPICH (experimental) directory tree")

set(PYTHON ON CACHE BOOL "Enable Python ?")
set(PYTHONDIR "" CACHE PATH "Specifiy the use Python directory tree")
set(PYTHONVERSION "" CACHE STRING "Specify the Python version to use")

set(GSHHS OFF CACHE BOOL "Enable GSHHS ?")
set(GSHHSDIR "" CACHE PATH "Specifiy the GSHHS directory tree")

set(NCURSESDIR "" CACHE PATH "Specify the ncurses (or curses) directory tree")

set(OPENMP ON CACHE BOOL "Enable OpenMP ?")

# Third party libraries
set(JASPERDIR "" CACHE PATH "Specify the JasPer directory tree")
set(JPEGDIR "" CACHE PATH "Specify the JPEG directory tree")
set(SZIPDIR "" CACHE PATH "Specify the SZip directory tree")

set(GDL_DATA_DIR "/share/gnudatalanguage" CACHE PATH "Choose data install directory relative to CMAKE_INSTALL_PREFIX")


# check for 64-bit OS
if(${CMAKE_SIZEOF_VOID_P} EQUAL 8)
	set(HAVE_64BIT_OS 1)
endif(${CMAKE_SIZEOF_VOID_P} EQUAL 8)


#### check headers and libraries

# dl
check_library_exists(dl dlopen "" HAVE_DL)
if(HAVE_DL)
	set(LIBRARIES ${LIBRARIES} dl)
endif(HAVE_DL)

# malloc stats
check_function_exists(malloc_zone_statistics HAVE_MALLOC_ZONE_STATISTICS)
check_function_exists(sbrk HAVE_SBRK)
check_function_exists(mallinfo HAVE_MALLINFO)

# mallocs
check_include_file(malloc.h HAVE_MALLOC_H)
check_include_file(malloc/malloc.h HAVE_MALLOC_MALLOC_H)

# locale
check_include_file(locale.h HAVE_LOCALE_H)

# std includes..
check_include_file(stdint.h HAVE_STDINT_H)
check_include_file(stdlib.h HAVE_STDLIB_H)
check_include_file(string.h HAVE_STRING_H)
check_include_file(strings.h HAVE_STRINGS_H)
check_include_file(sys/stat.h HAVE_SYS_STAT_H)
check_include_file(sys/types.h HAVE_SYS_TYPES_H)
check_include_file(unistd.h HAVE_UNISTD_H)

# dlfcn.h
check_include_file(dlfcn.h HAVE_DLFCN_H)

# inttypes.h
check_include_file(inttypes.h HAVE_INTTYPES_H)

# nexttoward
check_library_exists(m nexttoward "" HAVE_NEXTTOWARD)

# mpi
check_include_file(mpi.h HAVE_MPI_H)

# Ncurses MANDATORY
# -DNCURSESDIR=DIR
set(CMAKE_PREFIX_PATH ${NCURSESDIR})	
set(CURSES_NEED_NCURSES TRUE)
find_package(Curses QUIET COMPONENTS initscr)
mark_as_advanced(CURSES_CURSES_H_PATH CURSES_FORM_LIBRARY CURSES_HAVE_CURSES_H)
if(CURSES_FOUND)
	set(HAVE_LIBNCURSES 1)
	set(LIBRARIES ${LIBRARIES} ${CURSES_LIBRARIES})
	include_directories(${CURSES_INCLUDE_DIR})
else(CURSES_FOUND)
	# search for curses
	set(CURSES_NEED_NCURSES FALSE)
	find_package(Curses COMPONENTS initscr)
	set(HAVE_LIBCURSES ${CURSES_FOUND})
	if(CURSES_FOUND)
		set(LIBRARIES ${LIBRARIES} ${CURSES_LIBRARIES})
		include_directories(${CURSES_INCLUDE_DIR})
	else(CURSES_FOUND)
		message(FATAL_ERROR "(N)Curses was not found.\n"
		"Use -DNCURSESDIR=DIR to specify the (n)curses directory tree.")
	endif(CURSES_FOUND)
endif(CURSES_FOUND)

# Readline
# -DREADLINE=ON|OFF
# -DREADLINEDIR=DIR
if(READLINE)
	# readline needs (n)curses
	set(CMAKE_PREFIX_PATH ${READLINEDIR})
	find_package(Readline QUIET)
	set(HAVE_LIBREADLINE ${READLINE_FOUND})
	if(READLINE_FOUND)
		set(CMAKE_REQUIRED_LIBRARIES ${CURSES_LIBRARIES})
		check_library_exists("${READLINE_LIBRARIES}" rl_get_screen_size "" RL_GET_SCREEN_SIZE)
		if(NOT RL_GET_SCREEN_SIZE)
			message(STATUS "WARNING: Older GNU readline without rl_get_screen_size was found.\n"
			"For resized terminals the size might not be updated correctly.\n"
			"If this is a problem please install a recent version of readline.")
		endif(NOT RL_GET_SCREEN_SIZE)
		set(LIBRARIES ${LIBRARIES} ${READLINE_LIBRARIES})
		include_directories(${READLINE_INCLUDE_DIR})
		set(CMAKE_REQUIRED_LIBRARIES)
	else(READLINE_FOUND)
		message(FATAL_ERROR "GNU readline was not found.\n"
		"Use -DREADLINEDIR=no to explicitely disable it.")
	endif(READLINE_FOUND)
endif(READLINE)

# zlib MANDATORY
# -DZLIBDIR=DIR
set(CMAKE_PREFIX_PATH ${ZLIBDIR})
find_package(ZLIB QUIET)
set(HAVE_LIBZ ${ZLIB_FOUND})
if(ZLIB_FOUND)
	set(LIBRARIES ${LIBRARIES} ${ZLIB_LIBRARIES})
	include_directories(${ZLIB_INCLUDE_DIR})
else(ZLIB_FOUND)
	message(FATAL_ERROR "ZLib library is required but was not found.\n"
	"Use -DZLIBDIR=DIR to specify the zlib directory tree.")
endif(ZLIB_FOUND)

# openmp
# -DOPENMP=ON|OFF
if(OPENMP)
	find_package(OpenMP QUIET)
	if(OPENMP_FOUND)
		add_definitions(${OpenMP_CXX_FLAGS})
		set(LIBRARIES ${LIBRARIES} ${OpenMP_CXX_FLAGS})
	endif(OPENMP_FOUND)
endif(OPENMP)

# GSL MANDATORY
# -DGSLDIR=DIR
set(CMAKE_PREFIX_PATH ${GSLDIR})
find_package(GSL QUIET)
set(HAVE_LIBGSL ${GSL_FOUND})
set(HAVE_LIBGSLCBLAS ${GSL_FOUND})
if(GSL_FOUND)
	set(LIBRARIES ${LIBRARIES} ${GSL_LIBRARIES})
	include_directories(${GSL_INCLUDE_DIR})
else(GSL_FOUND)
	message(FATAL_ERROR "Gnu Scientific library (1.7 or higher) and libgslcblas are mandatory.\n"
	"Use -DGSLDIR=DIR to specify the gsl directory tree.")
endif(GSL_FOUND)

# PLplot MANDATORY
# -DOLDPLPLOT=ON|OFF
# -DPLPLOTDIR=DIR
set(HAVE_OLDPLPLOT ${OLDPLPLOT})
set(CMAKE_PREFIX_PATH ${PLPLOTDIR})
find_package(Plplot QUIET)
set(HAVE_LIBPLPLOTCXXD ${PLPLOT_FOUND})
if(PLPLOT_FOUND)
	set(LIBRARIES ${LIBRARIES} ${PLPLOT_LIBRARIES})
	include_directories(${PLPLOT_INCLUDE_DIR})
else(PLPLOT_FOUND)
	message(FATAL_ERROR "plplot library is required but was not found.\n"
	"Use -DPLPLOTDIR=DIR to specify the plplot directory tree.")
endif(PLPLOT_FOUND)
if(MAGICK) # support Magick
	check_library_exists("${PLPLOT_LIBRARIES}" plGetDrvDir "" HAVE_PLGETDRVDIR)
	if(HAVE_PLGETDRVDIR)
		message(STATUS "WARNING: Dynamic drivers have to be disabled in plplot.\n"
		"To make plplot work with ImageMagick:\n"
		"use -DENABLE_DYNDRIVERS=OFF cmake option when compiling plplot or\n"
		"use -DMAGICK=OFF here to not use ImageMagick in GDL.")
	endif(HAVE_PLGETDRVDIR)
endif(MAGICK)

# wxWdigets
# -DWXWIDGET=ON|OFF
# -DWXWIDGETDIR=DIR
if(WXWIDGETS)
	set(CMAKE_PREFIX_PATH ${WXWIDGETSDIR})
	find_package(wxWidgets QUIET)
	set(HAVE_LIBWXWIDGETS ${wxWidgets_FOUND})
	if(wxWidgets_FOUND)
		set(LIBRARIES ${LIBRARIES} ${wxWidgets_LIBRARIES})
		set(LINK_DIRECTORIES ${LINK_DIRECTORIES} ${wxWidgets_LIBRARY_DIRS})
		foreach(WXDEF ${wxWidgets_DEFINITIONS})
			add_definitions(-D${WXDEF})
		endforeach(WXDEF ${wxWidgets_DEFINITIONS})
		include_directories(${wxWidgets_INCLUDE_DIRS})
	else(wxWidgets_FOUND)
		message(FATAL_ERROR "wxWidgets are required but were not found.\n"
		"Use -DWXWIDGETSDIR=DIR to specify the wxWidgets directory tree.\n"
		"Use -DWXWIDGETS=OFF to not use it.")
	endif(wxWidgets_FOUND)
endif(WXWIDGETS)

# Magick
# -DMAGICK=ON|OFF
# -DMAGICKDIR=DIR
if(MAGICK)
	set(CMAKE_PREFIX_PATH ${MAGICKDIR})
	find_package(ImageMagick QUIET COMPONENTS Magick++ MagickWand MagickCore)
	mark_as_advanced(ImageMagick_EXECUTABLE_DIR ImageMagick_Magick++_INCLUDE_DIR ImageMagick_Magick++_LIBRARY
	ImageMagick_MagickCore_INCLUDE_DIR ImageMagick_MagickCore_LIBRARY ImageMagick_MagickWand_INCLUDE_DIR ImageMagick_MagickWand_LIBRARY)
	set(USE_MAGICK ${ImageMagick_FOUND})
	if(ImageMagick_FOUND)
		find_program(MAGICKXXCONFIG Magick++-config)
		if(MAGICKXXCONFIG)
			execute_process(COMMAND ${MAGICKXXCONFIG} "--libs" OUTPUT_VARIABLE MAGICKXXCONFIGLIBS OUTPUT_STRIP_TRAILING_WHITESPACE)
			set(LIBRARIES ${LIBRARIES} ${MAGICKXXCONFIGLIBS})		
		else(MAGICKXXCONFIG)
			message(FATAL_ERROR "ImageMagick is required but was not found (Magick++-config).\n"
			"Use -DMAGICKDIR=DIR to specify the ImageMagick directory.\n"
			"Use -DMAGICK=OFF to not use it.")
		endif(MAGICKXXCONFIG)
		set(LIBRARIES ${LIBRARIES} ${ImageMagick_LIBRARIES})
		include_directories(${ImageMagick_INCLUDE_DIRS})
		set(MAGICK_LIBRARIES ${ImageMagick_LIBRARIES})
	else(ImageMagick_FOUND)
		message(FATAL_ERROR "ImageMagick is required but was not found.\n"
		"Use -DMAGICKDIR=DIR to specify the ImageMagick directory.\n"
		"Use -DMAGICK=OFF to not use it.")
	endif(ImageMagick_FOUND)
endif(MAGICK)

# netCDF
# -DNETCDF=ON|OFF
# -DNETCDFDIR=DIR
if(NETCDF)
	set(CMAKE_PREFIX_PATH ${NETCDFDIR})
	find_package(NetCDF QUIET)
	if(NETCDF_FOUND)
		set(CMAKE_REQUIRED_INCLUDES ${NETCDF_INCLUDE_DIRS})
		check_include_file_cxx(netcdfcpp.h HAVE_NETCDFCPP_H)
		if(HAVE_NETCDFCPP_H)
			set(LIBRARIES ${LIBRARIES} ${NETCDF_LIBRARIES})
			set(LINK_DIRECTORIES ${LINK_DIRECTORIES} ${NETCDF_LIBRARY_DIR})
			include_directories(${NETCDF_INCLUDE_DIRS})
			set(USE_NETCDF 1)
		else(HAVE_NETCDFCPP_H)
			message(FATAL_ERROR "NetCDF installation seems not to be usable.\n"
			"This suggests a conflicting netCDF-HDF4 installation e.g.\n"
			"- Uninstalling HDF4 after installation of NetCDF.\n"
			"- Installing NetDCF before HDF4.")
		endif(HAVE_NETCDFCPP_H)
		set(CMAKE_REQUIRED_INCLUDES)
	else(NETCDF_FOUND)
		message(FATAL_ERROR "NetCDF version 3.5.1 or later is required but was not found.\n"
		"Use -DNETCDFDIR=DIR to specify the netcdf directory tree.\n"
		"Use -DNETCDF=OFF to not use it.")	
	endif(NETCDF_FOUND)
endif(NETCDF)

# hdf4
# -DHDF=ON|OFF
# -DHDFDIR=DIR
if(HDF)
	set(CMAKE_PREFIX_PATH ${HDFDIR} ${JPEGDIR} ${SZIPDIR})
	find_package(HDF QUIET)
	set(USE_HDF ${HDF_FOUND})
	if(HDF_FOUND)
		if(NETCDF)
			set(CMAKE_REQUIRED_LIBRARIES ${HDF_EXTRA_LIBRARIES})
                        check_library_exists("${HDF_LIBRARIES}" sd_nccreate "" SD_NCCREATE)
			if(NOT SD_NCCREATE)
				message(FATAL_ERROR "HDF4 needs to be configured with the --disable-netcdf option "
				"in order to be used with the original netCDF library.")
			endif(NOT SD_NCCREATE)
			set(CMAKE_REQUIRED_LIBRARIES)
		endif(NETCDF)
		set(HDF_LIBRARIES ${HDF_LIBRARIES} ${HDF_EXTRA_LIBRARIES})
		set(LIBRARIES ${LIBRARIES} ${HDF_LIBRARIES})
		include_directories(${HDF_INCLUDE_DIR})
	else(HDF_FOUND)
		message(FATAL_ERROR "HDF4 libraries were not found.\n"
		"Use -DHDFDIR=DIR to specify the HDF directory tree.\n"
		"Use -DHDF=OFF to not use it. "
		"You can use -DJPEGDIR=DIR to specify the JPEG directory tree. "
		"You can also use -DSZIPDIR=DIR to specify SZip directory tree if "
		"HDF was compiled with SZip support.")
	endif(HDF_FOUND)
endif(HDF)

# hdf5
# -DHDF5=ON|OFF
# -DHDF5DIR=DIR
if(HDF5)
	set(CMAKE_PREFIX_PATH ${HDF5DIR} ${SZIPDIR})

=== src/CMakeLists.txt ===
set(SOURCES
CFMTLexer.cpp
CFMTLexer.hpp
CFMTTokenTypes.hpp
FMTIn.cpp
FMTIn.hpp
FMTInTokenTypes.hpp
FMTLexer.cpp
FMTLexer.hpp
FMTOut.cpp
FMTOut.hpp
FMTOutTokenTypes.hpp
FMTParser.cpp
FMTParser.hpp
FMTTokenTypes.hpp
GDLInterpreter.cpp
GDLInterpreter.hpp
GDLInterpreterTokenTypes.hpp
GDLLexer.cpp
GDLLexer.hpp
GDLParser.cpp
GDLParser.hpp
GDLTokenTypes.hpp
GDLTreeParser.cpp
GDLTreeParser.hpp
GDLTreeParserTokenTypes.hpp
accessdesc.hpp
arrayindex.cpp
arrayindex.hpp
arrayindexlistt.hpp
assocdata.cpp
assocdata.hpp
basegdl.cpp
basegdl.hpp
basic_fun.cpp
basic_fun.hpp
basic_fun_cl.cpp
basic_fun_cl.hpp
basic_fun_jmg.cpp
basic_fun_jmg.hpp
basic_op.cpp
basic_pro.cpp
basic_pro.hpp
basic_pro_jmg.cpp
basic_pro_jmg.hpp
cformat.g
color.cpp
color.hpp
convert2.cpp
convol.cpp
convol_inc0.cpp
convol_inc1.cpp
convol_inc2.cpp
datalistt.hpp
datatypes.cpp
datatypes.hpp
datatypesref.cpp
dcommon.cpp
dcommon.hpp
dcompiler.cpp
dcompiler.hpp
default_io.cpp
deviceps.hpp
devicesvg.hpp
devicewin.hpp
devicex.hpp
devicez.hpp
dimension.hpp
dinterpreter.cpp
dinterpreter.hpp
dnode.cpp
dnode.hpp
dnodefactory.hpp
dpro.cpp
dpro.hpp
dstructdesc.cpp
dstructdesc.hpp
dstructgdl.cpp
dstructgdl.hpp
dvar.cpp
dvar.hpp
envt.cpp
envt.hpp
extrat.cpp
extrat.hpp
fftw.cpp
fftw.hpp
file.cpp
file.hpp
fmtnode.cpp
fmtnode.hpp
format.g
format.in.g
format.out.g
gdlc.g
gdlc.i.g
gdlc.tree.g
gdleventhandler.cpp
gdleventhandler.hpp
gdlexception.cpp
gdlexception.hpp
gdlgstream.cpp
gdlgstream.hpp
gdljournal.cpp
gdljournal.hpp
gdlpsstream.cpp
gdlpsstream.hpp
gdlpython.cpp
gdlpython.hpp
gdlsvgstream.cpp
gdlsvgstream.hpp
gdlwidget.cpp
gdlwidget.hpp
gdlwinstream.cpp
gdlwinstream.hpp
gdlxstream.cpp
gdlxstream.hpp
gdlzstream.cpp
gdlzstream.hpp
getfmtast.cpp
getfmtast.hpp
graphics.cpp
graphics.hpp
grib.cpp
grib.hpp
gshhs.cpp
gshhs.hpp
gsl_fun.cpp
gsl_fun.hpp
gzstream.hpp
hdf5_fun.cpp
hdf5_fun.hpp
hdf_fun.cpp
hdf_fun.hpp
hdf_pro.cpp
hdf_pro.hpp
ifmt.cpp
image.cpp
image.hpp
initct.cpp
initsysvar.cpp
initsysvar.hpp
io.cpp
io.hpp
lapack.cpp
libinit.cpp
libinit_ac.cpp
libinit_cl.cpp
libinit_gm.cpp
libinit_jmg.cpp
libinit_mes.cpp
libinit_ng.cpp
magick_cl.cpp
magick_cl.hpp
math_fun.cpp
math_fun.hpp
math_fun_ac.cpp
math_fun_ac.hpp
math_fun_gm.cpp
math_fun_gm.hpp
math_fun_jmg.cpp
math_fun_jmg.hpp
math_fun_ng.cpp
math_fun_ng.hpp
math_utl.cpp
math_utl.hpp
mpi.cpp
mpi.hpp
ncdf_att_cl.cpp
ncdf_cl.cpp
ncdf_cl.hpp
ncdf_dim_cl.cpp
ncdf_var_cl.cpp
new.cpp
new.hpp
newprognode.cpp
objects.cpp
objects.hpp
ofmt.cpp
ofmt.hpp
plot3d_nr.cpp
plotting.cpp
plotting.hpp
print.cpp
print_tree.cpp
print_tree.hpp
prognode.cpp
prognodeexpr.cpp
read.cpp
real2int.hpp
sigfpehandler.cpp
sigfpehandler.hpp
specializations.hpp
str.cpp
str.hpp
strassenmatrix.hpp
terminfo.cpp
terminfo.hpp
topython.cpp
typedefs.hpp
typetraits.cpp
typetraits.hpp
widget.cpp
)

add_subdirectory(antlr)

include_directories(${CMAKE_SOURCE_DIR} ${CMAKE_SOURCE_DIR}/src ${CMAKE_SOURCE_DIR}/src/antlr)
link_directories(${LINK_DIRECTORIES})

if(PYTHON_MODULE) #libgdl
	set(SOURCES ${SOURCES} pythongdl.cpp)
	add_library(gdl SHARED ${SOURCES})
else(PYTHON_MODULE) #gdl
	set(SOURCES ${SOURCES} gdl.cpp)
	add_executable(gdl ${SOURCES})
endif(PYTHON_MODULE)

add_dependencies(gdl antlr) # be sure that antlr is built before gdl
target_link_libraries(gdl antlr) # link antlr against gdl
target_link_libraries(gdl ${LIBRARIES})
add_definitions(-DHAVE_CONFIG_H)

if(PYTHON_MODULE)
	install(TARGETS gdl DESTINATION ${CMAKE_INSTALL_PREFIX}/lib)
else(PYTHON_MODULE)
	install(TARGETS gdl DESTINATION ${CMAKE_INSTALL_PREFIX}/bin)
	set_target_properties(gdl PROPERTIES INSTALL_RPATH_USE_LINK_PATH TRUE)
endif(PYTHON_MODULE)

install(DIRECTORY ${CMAKE_SOURCE_DIR}/src/pro/ DESTINATION ${CMAKE_INSTALL_PREFIX}/${GDL_DATA_DIR}/lib
	PATTERN CVS EXCLUDE
	PATTERN checks EXCLUDE
	PATTERN Makefile* EXCLUDE
	PATTERN UrgentNeed.txt EXCLUDE)

=== testsuite/CMakeLists.txt ===
set(BASE_SOURCE ${CMAKE_SOURCE_DIR})
set(BASE_BINARY ${CMAKE_BINARY_DIR})
# write the test launcher
set(LAUNCH
"#include<unistd.h>
#include<stdlib.h>
int main(int c,char**v) {
char*p;
if(c!=2) return 1;
for(p=v[1];*p;++p);
if(p-4<v[1]) return 1;
if(p[-1]!='o'||p[-2]!='r'||p[-3]!='p'||p[-4]!='.') return 1;
*(p-4)=0;
setenv(\"LC_COLLATE\",\"C\",1);
setenv(\"GDL_PATH\",\"+${BASE_SOURCE}/testsuite/:+${BASE_SOURCE}/src/pro/\",1);
execl(\"${BASE_BINARY}/src/gdl\",\"-quiet\",\"-e\",v[1],(char*)0);
}
")
file(WRITE ${CMAKE_SOURCE_DIR}/testsuite/launchtest.c "${LAUNCH}")
add_executable(launchtest ${CMAKE_SOURCE_DIR}/testsuite/launchtest.c)

set(TESTS
  test_angles.pro
  test_base64.pro
  test_binfmt.pro 
  test_bug_1779553.pro 
  test_bug_2555865.pro 
  test_bug_2610174.pro 
  test_bug_2846561.pro 
  test_bug_2876150.pro 
  test_bug_2876161.pro 
  test_bug_2974380.pro 
  test_bug_3033108.pro 
  test_bug_3054361.pro 
  test_bug_3055720.pro 
  test_bug_3057511.pro 
  test_bug_3057520.pro 
  test_bug_3061072.pro 
  test_bug_3081887.pro 
  test_bug_3085858.pro 
  test_bug_3086851.pro 
  test_bug_3091599.pro 
  test_bug_3091610.pro 
  test_bug_3100945.pro 
  test_bug_3104209.pro 
  test_bug_3104214.pro 
  test_bug_3104326.pro 
  test_bug_3104349.pro 
  test_bug_3147146.pro 
  test_bug_3147181.pro 
  test_bug_3151760.pro 
  test_ce.pro 
  test_clip.pro 
  test_common.pro 
  test_constants.pro 
  test_deriv.pro 
  test_device.pro 
  test_dicom.pro 
  test_erfinv.pro 
  test_execute.pro 
  test_fft.pro 
  test_fft_leak.pro 
  test_file_basename.pro 
  test_file_copy.pro 
  test_file_delete.pro 
  test_file_dirname.pro
  test_file_search.pro 
  test_fix.pro 
  test_fixprint.pro 
  test_gc.pro 
  test_get_screen_size.pro 
  test_grib.pro 
  test_hist_2d.pro 
  test_idl8.pro 
  test_interpol.pro 
  test_memory.pro 
  test_moment.pro 
  test_mpfit.pro 
  test_multiroots.pro 
  test_nans_in_sort_and_median.pro 
  test_nestedloop.pro 
  test_plotting_ranges.pro 
  test_pmulti.pro 
  test_product.pro 
  test_ps_decomposed.pro 
  test_python.pro 
  test_python_module_0.pro 
  test_python_module_1.pro 
  test_python_module_2.pro 
  test_readf.pro 
  test_rebin.pro 
  test_rk4.pro 
  test_spher_harm.pro 
  test_spl_init.pro 
  test_step.pro 
  test_str_functions.pro 
  test_strsplit.pro
  test_suite.pro 
  test_url.pro 
  test_wavelet.pro 
  test_zeropoly.pro 
  test_zip.pro 
  test_zzz.pro 
)
get_target_property(LAUNCHTESTLOCATION launchtest LOCATION)
foreach(TEST ${TESTS})
	add_test(${TEST} ${LAUNCHTESTLOCATION} ${TEST})
endforeach(TEST TESTS)

=== src/antlr/CMakeLists.txt ===
aux_source_directory(${CMAKE_CURRENT_SOURCE_DIR} ANTLRSOURCES)
list(REMOVE_ITEM ANTLRSOURCES ${CMAKE_CURRENT_SOURCE_DIR}/dll.cpp)
include_directories(${CMAKE_SOURCE_DIR} ${CMAKE_SOURCE_DIR}/src ${CMAKE_SOURCE_DIR}/src/antlr)

if(PYTHON_MODULE)
	add_library(antlr SHARED ${ANTLRSOURCES})
	install(TARGETS antlr DESTINATION ${CMAKE_INSTALL_PREFIX}/lib)
else(PYTHON_MODULE)
	add_library(antlr STATIC ${ANTLRSOURCES})
endif(PYTHON_MODULE)

=== debian/changelog ===
gnudatalanguage (0.9.1-1build1) oneiric; urgency=low

  * Rebuild against libgrib-api-0d-1.

 -- Colin Watson <cjwatson@ubuntu.com>  Thu, 25 Aug 2011 10:53:34 +0100

gnudatalanguage (0.9.1-1) unstable; urgency=low

  * New upstream release
    - debian/control, debian/rules: Transition from Python Numarray to Numpy
    - debian/patches/autoreconf-result: Refreshed by running autoreconf again
    - debian/patches/fix-muldefs: Refreshed
  * debian/patches/fix-muldefs: Added patch description 
  * debian/control, debian/rules: Do not build with grip support on the
    sparc, mips, hppa and hurd-i386 architectures. This should prevent
    uninstallable build dependencies on these architectures.

 -- Axel Beckert <abe@debian.org>  Thu, 31 Mar 2011 23:04:38 +0200

gnudatalanguage (0.9-2) unstable; urgency=low

  [ Axel Beckert ]
  * debian/patches/fix-muldefs: Patch configure.in to pass linker flags
    properly to compiler to fix FTBFS on some architectures. (Hopefully
    finally closes: #545849)

  [ Gürkan Sengün ]
  * Remove alternative dependency on libhdf4-dev and use libhdf4-alt-dev
    exclusively. Upstream now needs different configure options depending
    on the hd4 version used. (Actually already happened in the last upload.)

 -- Axel Beckert <abe@debian.org>  Wed, 09 Mar 2011 13:58:52 +0100

gnudatalanguage (0.9-1) unstable; urgency=low

  [ Gürkan Sengün ]
  * New upstream version. (Closes: #570204)
    - Fixes bug that routines in src/pro/ are not included by default.
      (LP: 288974)
    - Fixes FTBFS with gcc-4.5. (Closes: #564994)
  * Update b-d libreadline5-dev to libreadline-dev. (Closes: #553772)
  * Bump standards version to 3.9.1.
  * Switch to source format 3.0.
  * Add support for udunits, grib, wxwidgets.
  * Fix lintian warning about debhelper-but-no-misc-depends.
  * Updated long description.

  [ Axel Beckert ]
  * Add myself as uploader.
  * Acknowledge and merge NMU by Julien Cristau.
  * Reran autoreconf again, merged back the changes, upstream made to
    generated INSTALL file.
  * debian/rules: Also remove config.log in clean target
  * No more use the embedded copy of antlr but b-d on Debian's
    libantlr-dev. (Closes: #504857)

 -- Gürkan Sengün <gurkan@phys.ethz.ch>  Tue, 15 Feb 2011 23:04:13 +0100

gnudatalanguage (0.9~rc3-1.1) unstable; urgency=high

  * Non-maintainer upload.
  * Run autoconf so the patch from bug#495470 is not just applied to
    configure.in, but also configure (closes: #545849).

 -- Julien Cristau <jcristau@debian.org>  Wed, 19 May 2010 23:35:41 +0200

gnudatalanguage (0.9~rc3-1) unstable; urgency=low

  * New upstream version. (Closes: #531719)
  * Disable the python modules since upstream doesn't support
    python-numpy yet. (Closes: #478446, #549811)

 -- Gürkan Sengün <gurkan@phys.ethz.ch>  Mon, 28 Sep 2009 09:38:53 +0200

gnudatalanguage (0.9~rc2+20090903-1) unstable; urgency=low

  * New upstream version. (Closes: #500136)
  * Update build-depends. (Closes: #540401)
  * Bump debhelper version.
  * Bump standards version.

 -- Gürkan Sengün <gurkan@phys.ethz.ch>  Thu, 03 Sep 2009 09:30:08 +0200

gnudatalanguage (0.9~rc1-1.2) unstable; urgency=low

  * Non-maintainer upload to fix FTBFS and other bugs.
  * Applied patch provided by naoliv to make gnudatalanguage compile with
    the new imagemagick (Closes: #485894)
  * Applied patch provided by Martin Michlmayr to make gnudatalanguage
    compile with gcc 4.4 (Closes: #504861)
  * Applied improved watch file, thanks to Daniel Leidert for the file.
    (Closes: #480455)
  * Changed fftw3-dev to libfftw3-dev at Build-Depends, thanks to Marco
    Rodrigues for the report. (Closes: #488169)
  * Changed netcdfg-dev to libnetcdfg-dev at Build-Depends.

 -- Margarita Manterola <marga@debian.org>  Wed, 27 May 2009 00:14:58 +0000

gnudatalanguage (0.9~rc1-1.1) unstable; urgency=low

  * Non-maintainer upload.
  * Fix FTBFS on arm, armel, mips, mipsel due to invalid LDFLAGS line.
    (Closes: #495470)

 -- Thiemo Seufer <ths@debian.org>  Tue, 19 Aug 2008 15:00:55 +0200

gnudatalanguage (0.9~rc1-1) unstable; urgency=low

  * New upstream version. (Closes: #470244)
  * Updated my email address.

 -- Gürkan Sengün <gurkan@phys.ethz.ch>  Sun, 06 Apr 2008 14:22:21 +0200

gnudatalanguage (0.9~pre6-1.1) unstable; urgency=low

  * Non-maintainer upload.
  * Fix FTBFS with GCC 4.3: missing #includes, thanks to Maximiliano Curia for
  * the patch. (Closes: #456058)

 -- Christoph Berg <myon@debian.org>  Fri, 04 Apr 2008 18:34:32 +0200

gnudatalanguage (0.9~pre6-1) unstable; urgency=low

  * Initial release. (Closes: #304159)
    Thanks to Juan A. Añel, Sergio Gelato, and Christian
    T. Steigies for their previous work on this package.

 -- Gürkan Sengün <gurkan@linuks.mine.nu>  Thu, 25 Oct 2007 13:59:49 +0200

=== debian/control ===
Source: gnudatalanguage
Maintainer: Gürkan Sengün <gurkan@phys.ethz.ch>
Uploaders: Juan A. Añel <aetherlux@gulo.org>, Axel Beckert <abe@debian.org>
Section: interpreters
Priority: optional
Build-Depends: debhelper (>= 7), autotools-dev, libfftw3-dev, libgsl0-dev, libhdf4-alt-dev, libhdf5-serial-dev, libmagick++-dev, libplplot-dev, libreadline-dev, zlib1g-dev, libnetcdf-dev, libudunits2-dev, libgrib-api-dev [!sparc !mips !hppa !hurd-i386], libwxgtk2.8-dev, libantlr-dev, python-all-dev, python-numpy
Standards-Version: 3.9.1
Homepage: http://gnudatalanguage.sourceforge.net/

Package: gnudatalanguage
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: plplot9-driver-xwin, python-numpy
Description: Free IDL compatible incremental compiler
 A free IDL (Interactive Data Language) compatible incremental compiler.
 It has full syntax compatibility with IDL 7.1. IDL is a registered trademark
 of ITT Visual Information Solutions.

## gnudatalanguage 0.9.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,9 +1,20 @@
+#
+# copyright : (c) 2010 Maxime Lenoir and Alain Coulais
+#
+#  This program is free software; you can redistribute it and/or modify
+#  it under the terms of the GNU General Public License as published by
+#  the Free Software Foundation; either version 2 of the License, or
+#  (at your option) any later version.
+#
+
 # tested with 2.4 and doesn't seem to run.
 cmake_minimum_required(VERSION 2.6 FATAL_ERROR)
 
 project(GDL)
 
-set(VERSION "0.9 CVS")
+# we hope a 0.9.2 very soon !
+# set(VERSION "0.9.2 CVS")
+set(VERSION "0.9.2")
 enable_testing()
 
 include(CheckIncludeFile)
@@ -37,6 +48,9 @@
 
 set(UDUNITS OFF CACHE BOOL "Enable UDUNITS-2 ?")
 set(UDUNITSDIR "" CACHE PATH "Specify the UDUNITS-2 directory tree")
+
+set(PSLIB ON CACHE BOOL "Enable pslib ?")
+set(PSLIBDIR "" CACHE PATH "Specify the pslib directory tree")
 
 set(GRIB OFF CACHE BOOL "Enable Grib ?")
 set(GRIBDIR "" CACHE PATH "Specifiy the GRIB directory tree")
@@ -115,6 +129,7 @@
 check_include_file(sys/stat.h HAVE_SYS_STAT_H)
 check_include_file(sys/types.h HAVE_SYS_TYPES_H)
 check_include_file(unistd.h HAVE_UNISTD_H)
+check_include_file(ext/stdio_filebuf.h HAVE_EXT_STDIO_FILEBUF_H)
 
 # dlfcn.h
 check_include_file(dlfcn.h HAVE_DLFCN_H)
@@ -127,6 +142,10 @@
 
 # mpi
 check_include_file(mpi.h HAVE_MPI_H)
+
+# SA: whithout it compilation of antlr fails if there's a conflicting 
+#     version of antlr in system-wide directories
+include_directories(src)
 
 # Ncurses MANDATORY
 # -DNCURSESDIR=DIR
@@ -306,7 +325,7 @@
 			message(FATAL_ERROR "NetCDF installation seems not to be usable.\n"
 			"This suggests a conflicting netCDF-HDF4 installation e.g.\n"
 			"- Uninstalling HDF4 after installation of NetCDF.\n"
-			"- Installing NetDCF before HDF4.")
+			"- Installing NetCDF before HDF4.")
 		endif(HAVE_NETCDFCPP_H)
 		set(CMAKE_REQUIRED_INCLUDES)
 	else(NETCDF_FOUND)
@@ -330,24 +349,3 @@
 			if(NOT SD_NCCREATE)
 				message(FATAL_ERROR "HDF4 needs to be configured with the --disable-netcdf option "
 				"in order to be used with the original netCDF library.")
-			endif(NOT SD_NCCREATE)
-			set(CMAKE_REQUIRED_LIBRARIES)
-		endif(NETCDF)
-		set(HDF_LIBRARIES ${HDF_LIBRARIES} ${HDF_EXTRA_LIBRARIES})
-		set(LIBRARIES ${LIBRARIES} ${HDF_LIBRARIES})
-		include_directories(${HDF_INCLUDE_DIR})
-	else(HDF_FOUND)
-		message(FATAL_ERROR "HDF4 libraries were not found.\n"
-		"Use -DHDFDIR=DIR to specify the HDF directory tree.\n"
-		"Use -DHDF=OFF to not use it. "
-		"You can use -DJPEGDIR=DIR to specify the JPEG directory tree. "
-		"You can also use -DSZIPDIR=DIR to specify SZip directory tree if "
-		"HDF was compiled with SZip support.")
-	endif(HDF_FOUND)
-endif(HDF)
-
-# hdf5
-# -DHDF5=ON|OFF
-# -DHDF5DIR=DIR
-if(HDF5)
-	set(CMAKE_PREFIX_PATH ${HDF5DIR} ${SZIPDIR})

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -25,9 +25,12 @@
 GDLTreeParser.hpp
 GDLTreeParserTokenTypes.hpp
 accessdesc.hpp
+allix.hpp
+allix.cpp
 arrayindex.cpp
 arrayindex.hpp
 arrayindexlistt.hpp
+arrayindexlistnoassoct.hpp
 assocdata.cpp
 assocdata.hpp
 basegdl.cpp
@@ -179,15 +182,33 @@
 ofmt.cpp
 ofmt.hpp
 plot3d_nr.cpp
+plotting_axis.cpp
+plotting_contour.cpp
+plotting_convert_coord.cpp
+plotting_cursor.cpp
+plotting_device.cpp
+plotting_erase.cpp
+plotting_map_proj.cpp
+plotting_misc.cpp
+plotting_oplot.cpp
+plotting_plot.cpp
+plotting_plots.cpp
+plotting_polyfill.cpp
+plotting_surface.cpp
+plotting_windows.cpp
+plotting_xyouts.cpp
 plotting.cpp
 plotting.hpp
 print.cpp
 print_tree.cpp
 print_tree.hpp
 prognode.cpp
+prognode_lexpr.cpp
 prognodeexpr.cpp
 read.cpp
 real2int.hpp
+semshm.cpp
+semshm.hpp
 sigfpehandler.cpp
 sigfpehandler.hpp
 specializations.hpp
@@ -205,7 +226,7 @@
 
 add_subdirectory(antlr)
 
-include_directories(${CMAKE_SOURCE_DIR} ${CMAKE_SOURCE_DIR}/src ${CMAKE_SOURCE_DIR}/src/antlr)
+include_directories(${CMAKE_SOURCE_DIR} ${CMAKE_SOURCE_DIR}/src ${CMAKE_SOURCE_DIR}/src/antlr ${CMAKE_BINARY_DIR})
 link_directories(${LINK_DIRECTORIES})
 
 if(PYTHON_MODULE) #libgdl
@@ -222,7 +243,8 @@
 add_definitions(-DHAVE_CONFIG_H)
 
 if(PYTHON_MODULE)
-	install(TARGETS gdl DESTINATION ${CMAKE_INSTALL_PREFIX}/lib)
+#	TODO: this library should go to Python library path (site-packages?)
+#	install(TARGETS gdl DESTINATION ${CMAKE_INSTALL_PREFIX}/lib)
 else(PYTHON_MODULE)
 	install(TARGETS gdl DESTINATION ${CMAKE_INSTALL_PREFIX}/bin)
 	set_target_properties(gdl PROPERTIES INSTALL_RPATH_USE_LINK_PATH TRUE)

=== testsuite/CMakeLists.txt ===
set(BASE_SOURCE ${CMAKE_SOURCE_DIR})
set(BASE_BINARY ${CMAKE_BINARY_DIR})
# write the test launcher
set(LAUNCH
"#include<unistd.h>
#include<stdlib.h>
int main(int c,char**v) {
char*p;
if(c!=2) return 1;
for(p=v[1];*p;++p);
if(p-4<v[1]) return 1;
if(p[-1]!='o'||p[-2]!='r'||p[-3]!='p'||p[-4]!='.') return 1;
*(p-4)=0;
setenv(\"LC_COLLATE\",\"C\",1);
setenv(\"GDL_PATH\",\"+${BASE_SOURCE}/testsuite/:+${BASE_SOURCE}/src/pro/\",1);
execl(\"${BASE_BINARY}/src/gdl\",\"-quiet\",\"-e\",v[1],(char*)0);
}
")
file(WRITE ${CMAKE_SOURCE_DIR}/testsuite/launchtest.c "${LAUNCH}")
add_executable(launchtest EXCLUDE_FROM_ALL ${CMAKE_SOURCE_DIR}/testsuite/launchtest.c)
add_library(test_ce SHARED EXCLUDE_FROM_ALL libtest_ce.cpp)
add_custom_target(check COMMAND ${CMAKE_BUILD_TOOL} test DEPENDS launchtest test_ce)
get_target_property(LAUNCHTESTLOCATION launchtest LOCATION)
execute_process(
  COMMAND "fgrep" ".pro" "${BASE_SOURCE}/testsuite/Makefile.am" 
  COMMAND "awk" "{printf(\"%s;\",$1)}" 
  OUTPUT_VARIABLE TESTS)
foreach(TEST ${TESTS})
	add_test(${TEST} ${LAUNCHTESTLOCATION} ${TEST})
endforeach(TEST TESTS)

=== debian/changelog ===
gnudatalanguage (0.9.2-4) unstable; urgency=low

  * Update architecture list for grib-api build-dependency. Use a positive
    list, so we use the same list as grib-api itself and rather miss new
    architectures than become unbuildable on new architectures.

 -- Axel Beckert <abe@debian.org>  Sat, 30 Jun 2012 12:35:34 +0200

gnudatalanguage (0.9.2-3) unstable; urgency=low

  * Import patch from upstream to remove plot3d_nr.cpp. Fixes FTBFS when
    building against newer plplot packages. (Closes: #660260, #669123,
    #669497) Thanks Sylwester Arabas!
  * Create patch to disable the WIDTH keyword and charheight based
    positional fine-tuning in the XYOUTS procedure as advised by
    upstream. (FTBFS otherwise, too)
  * Enable hardening build flags
    + Add build dependency on dpkg-dev (>= 1.16.1~)
  * Just use dh_autoreconf*, not both, dh_autoreconf* and
    dh_autotools-dev_*config as advised by dh_autoreconf docs.
  * Use dh_auto_clean instead of $(MAKE) distclean
  * Do not only remove embedded antlr copy before building, but also
    restore it again in the clean target.
  * Ignore any changes to Makefile.in files in the diff.
  * Don't require a present configure for config.status target. Fixes
    building twice in a row.
  * Update Recommends: plplot9-driver-xwin → plplot11-driver-xwin
  * Let dh_clean remove stamp files
  * Bump Standards-Version to 3.9.3 (no changes)
  * Remove Juan A. Añel from Uploaders (no activity since 2007)
  * Exchange Maintainer and Uploader.
  * Add lintian override for "configure-generated-file-in-source
    config.log" as it's removed in the clean target.
  * Add Vcs-* headers
  * Add patch to fix several man-page issues found by lintian.

 -- Axel Beckert <abe@debian.org>  Fri, 29 Jun 2012 17:52:27 +0200

gnudatalanguage (0.9.2-2) unstable; urgency=low

  * Changed the "libhdf5-serial-dev" build-dependency to "libhdf5-dev |
    libhdf5-serial-dev" for the HDF5 1.8.6 to 1.8.8 transition. (See
    http://bugs.debian.org/631019)
  * Changed priority from optional to extra to match override.
  * Fixed the following lintian warnings:
    - debian-rules-missing-recommended-target
    - copyright-refers-to-symlink-license

 -- Axel Beckert <abe@debian.org>  Wed, 18 Jan 2012 20:12:20 +0100

gnudatalanguage (0.9.2-1) unstable; urgency=low

  * New upstream release (Closes: #648476)
    - Fixes FTBFS. (Closes: #647802) Thanks to Daniel T Chen for
      investigation!
    - Add B-D on pslib-dev and add --with-pslib to configure call.
    - No more remove /usr/lib/libantlr.a from the package, it's no more
      built anymore.
    - Refresh patch fix-muldefs
    - Refresh patch build-with-debian-antlr-instead-embedded-one; remove
      parts applied upstream.
  * Install upstream man page, drop outdated debian/gdl.1. Thanks
    Sylwester Arabas! (Closes: #630481)
  * Use dh_autotools-dev_*config instead of manually copying
    config.{sub,guess}
  * Use dh_autoreconf instead of patching configure et al manually.
    - No more patch configure script, just configure.in in remaining
      patches.
  * Bump Standards-Version to 3.9.2 (no changes necessary)

 -- Axel Beckert <abe@debian.org>  Tue, 15 Nov 2011 23:18:56 +0100

=== debian/control ===
Source: gnudatalanguage
Maintainer: Axel Beckert <abe@debian.org>
Uploaders: Gürkan Sengün <gurkan@phys.ethz.ch>
Section: interpreters
Priority: extra
Build-Depends: debhelper (>= 7), autotools-dev, libfftw3-dev, libgsl0-dev, libhdf4-alt-dev, libhdf5-dev | libhdf5-serial-dev, libmagick++-dev, libplplot-dev, libreadline-dev, zlib1g-dev, libnetcdf-dev, libudunits2-dev, libgrib-api-dev [i386 amd64 ia64 powerpc s390 alpha armel mipsel kfreebsd-amd64 kfreebsd-i386 armhf], libwxgtk2.8-dev, libantlr-dev, python-all-dev, python-numpy, pslib-dev, dh-autoreconf, dpkg-dev (>= 1.16.1~)
Standards-Version: 3.9.3
Homepage: http://gnudatalanguage.sourceforge.net/
Vcs-Git: git://anonscm.debian.org/collab-maint/gnudatalanguage.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/gnudatalanguage.git

Package: gnudatalanguage
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: plplot11-driver-xwin, python-numpy
Description: Free IDL compatible incremental compiler
 A free IDL (Interactive Data Language) compatible incremental compiler.
 It has full syntax compatibility with IDL 7.1. IDL is a registered trademark
 of ITT Visual Information Solutions.

=== debian/rules ===
#!/usr/bin/make -f

# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
DEB_BUILD_ARCH      ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

ifeq ($(DEB_BUILD_ARCH),$(filter i386 amd64 ia64 powerpc s390 alpha armel mipsel kfreebsd-amd64 kfreebsd-i386 armhf,$(DEB_BUILD_ARCH)))
	GRIP = --with-grib
else
	GRIP = --without-grib
endif

config.status:
	dh_testdir
	tar cf antlr.tar src/antlr
	# Add here commands to configure the package.
	dh_autoreconf
	# Patched source FTBFS if this embedded code copy is present
	rm -rf src/antlr
	./configure --host=$(DEB_HOST_GNU_TYPE) --build=$(DEB_BUILD_GNU_TYPE) --prefix=/usr --mandir=\$${prefix}/share/man --infodir=\$${prefix}/share/info CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)" --with-fftw=yes --with-python=yes --with-wxWidgets $(GRIP) --with-udunits --with-pslib

build: build-arch build-indep
build-arch: build-stamp
build-indep: build-stamp
build-stamp: config.status
	dh_testdir
	$(MAKE)
	touch $@

clean:
	dh_testdir
	dh_testroot
	if [ -f  antlr.tar ]; then tar xf antlr.tar; fi
	rm -f antlr.tar
	dh_auto_clean
	dh_autoreconf_clean
	dh_clean --exclude ./src/ncdf_att_cl.cpp.orig --exclude ./src/basic_pro.cpp.orig --exclude ./src/basic_pro.hpp.orig --exclude ./src/libinit.cpp.orig --exclude ./src/ncdf_var_cl.cpp.orig --exclude configure~

install: build
	dh_testdir
	dh_testroot
	dh_prep --exclude ./src/ncdf_att_cl.cpp.orig --exclude ./src/basic_pro.cpp.orig --exclude ./src/basic_pro.hpp.orig --exclude ./src/libinit.cpp.orig --exclude ./src/ncdf_var_cl.cpp.orig --exclude configure~
	dh_installdirs
	$(MAKE) DESTDIR=$(CURDIR)/debian/gnudatalanguage install

binary-indep: build install

binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs ChangeLog
	dh_installdocs
	dh_installman doc/gdl.1
	dh_link
	dh_strip
	dh_compress -X.pro
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install
